#include <bits/stdc++.h>

using namespace std;

int main()
{
    ios_base::sync_with_stdio(false); cin.tie(NULL); cout.tie(NULL);

    int T;
    cin >> T;

    for(int t = 0;t<T;t++)
    {
        int N,M;
        cin >> N >> M;

        long long A[N],B[M];

        for(int i = 0;i<N;i++)
        {
            cin >> A[i];
        }
        for(int i = 0;i<M;i++)
        {
            cin >> B[i];
        }

        long long razlike[N-1];
        for(int i = 0;i<N-1;i++)
        {
            razlike[i] = abs(A[i] - A[i+1]);
            //cout << razlike[i] << " ";
        }
        long long r = razlike[0];
        for(int i = 0;i<N-2;i++)
        {
            //cout << r << "\t";
            r = __gcd(r,razlike[i+1]);

        }
        //cout << r << endl;

        bool res = true;

        for(int i = 0;i<M;i++)
        {
            if((B[i]-A[0]) % r == 0)
                res = false;
        }
        cout << res << endl;
    }

    return 0;
}